<?php

// generic strings
define ("STR_EDIT"            ,   "Edit");
define ("STR_ADD"             ,   "Add");
define ("STR_TITLE"           ,   "Title");
define ("STR_NEWFILE"         ,   "New File");
define ("STR_DESCR"           ,   "Description");
define ("STR_OF_SECTION"      ,   "of section:");

// error strings
define ("STR_ERR_PATH"        ,   "Two sections will have the same path:");
define ("STR_ERR_FIELD"       ,   "There are empty fields");
define ("STR_ERR_EXT"         ,   "File must have extention");
define ("STR_ERR_THUMB"       ,   "Thumbnail generation error");
define ("STR_ERR_SAVE"        ,   "Saving error");

// buttons strings
define ("STR_CMD_ADDSECTION"  ,   "Add Section");
define ("STR_CMD_SAVE"        ,   "Save");
define ("STR_CMD_REVERT"      ,   "Revert to last saved version");
define ("STR_CMD_MOVEHERE"    ,   "Move Here");
define ("STR_CMD_SERVERDEL"   ,   "Delete from server");
define ("STR_SHOWCOVER"       ,   "Show cover between section images (don't hide it)");
define ("STR_USE_AS_COVER"    ,   "Use as cover image");

function print_help($page){

	echo "<div class='warning'>";
	
	switch ($page){

	case "fix":
		echo "In this section you can modify some fixed files<br>\n";
		echo "To load files use <b>New file</b> field<br>\n";
		echo "Use <b>Delete from server</b> to delete the file without overwrite it<br>\n";		
		echo "Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Warning</b>: you must save to store your changes<br>\n";
		echo "Dependig from file dimension and connection speed save can ask a long time<br>\n";
		break;
	case "tree":
		echo "In this section you can modify the tree-structure<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item\n";
		echo "<li><span class='button'>".STR_ADD."</span> <span class='button'>".STR_CMD_ADDSECTION."</span> = Add a section/subsection\n";
		if (DONT_MOVE_TREE==0) echo "<li><span class='button'>".STR_CMD_MOVEHERE."</span> = Move selected item (<input type='radio' checked>) in this section (*)<br>";
		echo "<li><span class='button'>".STR_EDIT."</span> = Modify content (*)\n";
		echo "<li>(*)<small>only after save</small></ul>\n";
		echo "The number in parenthesis is the actual count of image in the section<br>\n";
		//echo "Il contenuto delle sezioni aventi sottosezioni &egrave automatico (&egrave l&#39;indice)<br>\n";
		echo "<b>Warning</b>: you must save to store your changes<br>\n";
		break;
	case "opt":
		echo "In this section you can modify the ".$_GET['optname']." list<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item</ul>\n";
		echo "<b>Warning</b>: you must save to store your changes<br>\n";
		break;
	case "section":
		echo "In this section you can modify the section content<br>\n";
		echo "To undo/redo use <b>back/next</b> buttons of your browser<br>\n";
		echo "To load images use <b>New file</b> field<br>\n";
		echo "To preserve your quality settings image dimension are not modified<br>\n";
		echo "Click on the thumbnail to see full size image<br>\n";
		echo "<ul><li><span class='button'>X</span> = Delete item\n";
		echo "<li><span class='button'>V</span> = Move down the item</ul>\n";
		echo "Maximum accepted file dimension is: <b>".ini_get( "upload_max_filesize")."b</b><br>\n";
		echo "<b>Warning</b>: you must save to store your changes<br>\n";
		echo "Dependig from file dimension and connection speed save can ask a long time<br>\n";
		break;
	}
	echo "</div>";
}

// print the html links menu
function print_header_with_menu($curr_page)
{
	global $optsection;
	
	echo "<h2>CMS - Edit $curr_page</h2>\n";
	echo "<div class='nav'>";

	if ("Menu"!=$curr_page) echo "<a  class='button' href='index.php'>Edit Menu</a>\n";
	else echo "<span class='inactivebutton'>Edit Menu</span>\n";
	
	foreach ($optsection as $optname)
		if ($optname!=$curr_page) 
			echo "<a class='button' href='index.php?page=optedit.php&optname=$optname'>Edit $optname</a>\n";
		else echo "<span class='inactivebutton'>Edit $optname</span>\n";
	if (FX_FILES_SECTION!="0") 
		if (FX_FILES_SECTION!=$curr_page) 	
			echo "<a class='button' href='index.php?page=fixedit.php'>Edit ".FX_FILES_SECTION."</a>\n";
		else echo "<span class='inactivebutton'>Edit ".FX_FILES_SECTION."</span>\n";
		
	echo "</div>";
}

function print_error($err_str)
{
	if ($err_str) echo "<div class='error'>Error: ".$err_str."</div>\n";
}

function format_stat_info($statary)
{
	if ($statary)
		return "File ".return_notation_bytes($statary[7],2)."b modified ".date("d/m/y",$statary[9])." at ".date("H:i",$statary[9])." (server time)";
	else return "No File";
}

?>


