<?php
// (C)2006 Matteo Lucarelli
// tree editing section

require_once("load-save.php");

function validate(){

	global $err_str,$tree;
	$err_str='';

	for ($i=0 ; $i<count($tree) ; $i++) $tree[$i]['LABEL']=clean_label($tree[$i]['LABEL']);

	$links=build_links();
	
	for ($i=0 ; $i<count($tree) ; $i++){
		if ($tree[$i]['LABEL']==''){
			$err_str.= STR_ERR_FIELD;
			$tree[$i]['ERRCH']="*";
			break;
		}
		for ($j=$i+1; $j<count($tree) ; $j++){
			if ($links[$i]==$links[$j]){
				$err_str.= STR_ERR_PATH." <b>".$links[$j]."</b>";
				$tree[$j]['ERRCH']="*";
				$tree[$i]['ERRCH']="*";
				break;
			}
		}
	}
}

$modified=TRUE;
$err_str='';

if (isset($_POST['tree'])) $tree=$_POST['tree'];
if (isset($_POST['tomove'])) $tomove=$_POST['tomove'];
if ($_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-iE

if (isset($_POST['cmd'])){

	if ($_POST['cmd']=='revert'){
		tree_load();
		$modified=FALSE;
	}
	
	if ($_POST['cmd']=='save'){
		validate();
		if ($err_str==''){
			if (($tomove[0]!="")&&($tomove[1]!="")){
				$cmd="mv ".ABS_PATH.DATA_DIR.$tomove[0]." ".ABS_PATH.DATA_DIR.$tomove[1]."/";
				system($cmd);
				unset($tomove);
			}
			tree_save();
			$modified=FALSE;
		}
	}	
	
	if (substr($_POST['cmd'],0,3)=='del'){
		$todel=substr($_POST['cmd'],3);
		for ($c=1;((($todel+$c)<count($tree))&&($tree[$todel+$c]['LEVEL']>$tree[$todel]['LEVEL']));$c++);
		for ($i=0;$i+$todel<count($tree);$i++) $tree[$todel+$i]=$tree[$todel+$i+$c];
		for (;$c>0;$c--) unset($tree[count($tree)-1]);
	}
	
	if (substr($_POST['cmd'],0,3)=='add'){
		$toadd=substr($_POST['cmd'],3);
		for ($i=count($tree);$i>$toadd;$i--) $tree[$i]=$tree[$i-1];
		$tree[$toadd]['LABEL']="";
		$tree[$toadd]['LINK']="";
		$tree[$toadd]['COUNT']=0;
		if (count($tree)>1) $tree[$toadd]['LEVEL']=$tree[$toadd+1]['LEVEL'];
		else $tree[$toadd]['LEVEL']=0;
	}
	
	if (substr($_POST['cmd'],0,3)=='sub'){
		$tosub=substr($_POST['cmd'],3);
		for ($i=count($tree);$i>$tosub+1;$i--) $tree[$i]=$tree[$i-1];
		$tree[$tosub+1]['LABEL']="";
		$tree[$tosub+1]['LINK']="";
		$tree[$tosub+1]['LEVEL']=$tree[$tosub]['LEVEL']+1;
		$tree[$tosub+1]['COUNT']=0;
	}
	
	if (substr($_POST['cmd'],0,3)=='mov'){
		$tomov=substr($_POST['cmd'],3);
		$lmov=$tree[$tomov]['LEVEL'];
		$treedown[0]=$tree[$tomov];
		for ($c=1;($tomov+$c)<count($tree);$c++){
			if ($tree[$tomov+$c]['LEVEL']<=$lmov) break;
			$treedown[$c]=$tree[$tomov+$c];
		}
		$tree[$tomov]=$tree[$tomov+$c];
		for ($u=1;($tomov+$c+$u)<count($tree);$u++){
			if ($tree[$tomov+$c+$u]['LEVEL']<=$lmov) break;
			$tree[$tomov+$u]=$tree[$tomov+$c+$u];
		}
		for ($i=0;$i<$c;$i++) $tree[$tomov+$u+$i]=$treedown[$i];
	}
	
	if ((substr($_POST['cmd'],0,3)=='mto')&&(DONT_MOVE_TREE==0)){
	
		// TODO: control for illogical movement
	
		if (isset($_POST['tomov'])){
		
			$movto=substr($_POST['cmd'],3);
			$tomov=$_POST['tomov'];
					
			// save value for real directory move
			$tomove[0]=$tree[$tomov]['LINK'];
			$tomove[1]=$tree[$movto]['LINK'];

			// the tree part that will move
			$treetomov[0]=$tree[$tomov];
			$treetomov[0]['LEVEL']=$tree[$movto]['LEVEL']+1;			
			$c=1;
			while ($tree[$tomov+$c]['LEVEL']>$tree[$tomov]['LEVEL']){
				$treetomov[$c]=$tree[$tomov+$c];
				$treetomov[$c]['LEVEL']=$tree[$movto]['LEVEL']+$tree[$tomov+$c]['LEVEL']-$tree[$tomov]['LEVEL']+1;
				$c++;
			}
			
			// shift the tree
			if ($movto<$tomov){
				for ($i=$tomov+$c-1;$i>$movto;$i--) $tree[$i]=$tree[$i-$c];
				for ($i=0;$i<count($treetomov);$i++) $tree[$movto+1+$i]=$treetomov[$i];
			}else if ($movto>$tomov){
				for ($i=$tomov;$i<$movto;$i++) $tree[$i]=$tree[$i+$c];
				for ($i=0;$i<count($treetomov);$i++) $tree[$movto+1-$c+$i]=$treetomov[$i];
			}
		}else{
			$err_str="Errore: Nessun elemento selezionato";
			$modified=FALSE;
		}
		
	}
	
}else if (tree_load()) $modified=FALSE;

print_header_with_menu("Menu");
print_help("tree");
print_error($err_str);

echo "<form method='post' action='index.php'>\n";
echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-iE
echo "<input type=hidden name='tomove[0]' value='".$tomove[0]."'>\n";
echo "<input type=hidden name='tomove[1]' value='".$tomove[1]."'>\n";

if (LOCK_UNTIL_LEVEL==0) echo "<button type='submit' name='cmd' value='add0' v='add0' onClick='ssval(this.v)'>".STR_CMD_ADDSECTION."</button>\n";
echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
if ($modified) 
	echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";

if (count($tree)!=0) {

	echo "<ul>\n";
	$cl=0;
	for($i=0 ; $i<count($tree); $i++){
	
		$islast=TRUE;
		for ($j=$i+1;$j<count($tree);$j++){
			if ($tree[$j]['LEVEL']<$tree[$i]['LEVEL']) break;
			if ($tree[$j]['LEVEL']==$tree[$i]['LEVEL']){
				$islast=FALSE;
				break;
			}
		}
		for (;$tree[$i]['LEVEL']>$cl;$cl++) echo "<ul>\n";
		for (;$tree[$i]['LEVEL']<$cl;$cl--) echo "</ul>\n";
		echo "<li>";
		echo "<input type='hidden' name='tree[$i][LINK]' value='".$tree[$i]['LINK']."'>\n";
		echo "<input type='hidden' name='tree[$i][LEVEL]' value='".$tree[$i]['LEVEL']."'>\n";
		echo "<input type='hidden' name='tree[$i][COUNT]' value='".$tree[$i]['COUNT']."'>\n";
		
		if (isset($tree[$i]['ERRCH'])) echo "<span class='error'>".$tree[$i]['ERRCH']."</span>";
		echo "<input type='text' name='tree[$i][LABEL]' value='".$tree[$i]['LABEL']."'>\n";
		if ($tree[$i]['LEVEL']>=LIMIT_CONTENT) 
			echo "(".$tree[$i]['COUNT'].")";
		if ($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL) echo "<button type='submit' name='cmd' value='del$i' v='del$i' onClick='ssval(this.v)'>X</button>\n";
		if (!$islast) 
			echo "<button type='submit' name='cmd' value='mov$i' v='mov$i' onClick='ssval(this.v)'>V</button>\n";
		if ($tree[$i]['LEVEL']<LIMIT_NEST) 
			echo "<button type='submit' name='cmd' value='sub$i' v='sub$i' onClick='ssval(this.v)'>".STR_CMD_ADDSECTION."</button>\n";
		if (!$modified){
			if ($tree[$i]['LEVEL']>=LIMIT_CONTENT)
				echo "<a class='button' href='index.php?page=sectionedit.php&path=".$tree[$i]['LINK']."'>".STR_EDIT."</a>\n";
			if (($tree[$i]['LEVEL']<LIMIT_NEST)&&(DONT_MOVE_TREE==0))	
				echo "<button type='submit' name='cmd' value='mto$i' v='mto$i' onClick='ssval(this.v)'>".STR_CMD_MOVEHERE."</button>\n";
			if (DONT_MOVE_TREE==0) echo "<input type='radio' name='tomov' value='$i'>";
		}
	}
	for (;$cl>=0;$cl--) echo "</ul>\n";
	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
	if ($modified) 
		echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
}
echo "</form>";

?>


